#!/bin/sh

set kludge { ${1+"$@"}
shift
shift
exec ical -f $0 -nodisplay ${1+"$@"}
}

# calendar cal $ical(calendar)
calendar cal "Calendar.save"

proc WIZ_parse {text tdate talarm {default_date ""}} {
    set type notice
    set date $default_date

    if [catch {set alarms [$item alarms]}] {
	set alarms [cal option DefaultAlarms]
    }
    set alarms $talarm
# puts stderr "WIZ"
# puts stderr $alarms
    if ![string compare $tdate ""] {set date [date today]}

    if [date extract $tdate d j1 j2] {
        set date $d
    }

    if [ical_time extract_range $tdate start finish j1 j2] {
        set type appt
    } elseif {[ical_time extract_time $tdate start j1 j2]} {
        set finish [expr $start + 60*60]
        if {$finish > 24*60*60} {set finish [expr 24*60*60]}
        set type appt
    }

    if ![string compare $type notice] {
        set id [notice]
    } else {
        set id [appointment]
        $id starttime [expr $start/60]
        $id length    [expr ($finish - $start)/60];
    }

    $id date $date
    $id earlywarning [cal option DefaultEarlyWarning]
    if [string compare $type notice] {
	$id alarms $talarm
    }
    $id own
    $id text $text
    return $id
}

# puts stderr [lindex $argv 0]
# puts stderr [lindex $argv 1]
set text {}
while {[gets stdin line] >= 0} {
    lappend text $line
}
set text [join $text "\n"]

set Apps  [lindex $argv 1]
if {$Apps  < 0} {
    set item [WIZ_parse $text [lindex $argv 0] {}] 
} else {
    set item [WIZ_parse $text [lindex $argv 0] [list 0 0 0 [lindex $argv 1]]]
}
cal add $item
cal save "Calendar.save"

if [catch {set Alarm [lindex [$item alarms] 1]}] {
    set Alarm {}
}
puts stderr =====
puts stderr [date2text [$item first]]
# puts -nonewline stderr [lindex [$item alarms] 1]
puts -nonewline stderr $Alarm
puts -nonewline stderr [item2text $item]
puts stderr =====
# puts stderr $item
# puts stderr [$item first]


